//---- indicator settings
#property  indicator_separate_window
//#property  indicator_chart_window
#property  indicator_buffers 2
#property indicator_color1 SpringGreen
#property indicator_color2 Crimson
//#property indicator_color3 Magenta

#property indicator_width1 2
#property indicator_width2 2
//#property indicator_width3 2
//---- indicator parameters
extern int FastHMA = 9; 
extern int SlowHMA = 21; 
//---- indicator buffers
double	OsmaBuffer[];
double	PreHMA1[]; 
double	PreHMA2[]; 
double Uptrend[];
double Dntrend[];


//+------------------------------------------------------------------+
int pF, pS; 

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- 4 additional buffers are used for counting.
   IndicatorBuffers(5);
   
//---- drawing settings
   SetIndexStyle(0,DRAW_LINE);
   SetIndexDrawBegin(0,SlowHMA);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexDrawBegin(1,SlowHMA);

 //  SetIndexStyle(2,DRAW_LINE);
 //  SetIndexDrawBegin(2,SlowHMA);
   
   IndicatorDigits(Digits+2);
   
//---- 5 indicator buffers mapping
   SetIndexBuffer(0,Uptrend);
   SetIndexBuffer(1,Dntrend);
   SetIndexBuffer(2,OsmaBuffer);
   SetIndexBuffer(3,PreHMA1);
   SetIndexBuffer(4,PreHMA2);

//   SetIndexBuffer(2,PreHMA2);
   
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("OsHMA("+FastHMA+","+SlowHMA+")");
   
	pF = MathSqrt(FastHMA); 
	pS = MathSqrt(SlowHMA); 
	
//---- initialization done
   return(0);
  }

  
//+------------------------------------------------------------------+
double WMA(int x, int p) { 
	return(iMA(NULL, 0, p, 0, MODE_LWMA, PRICE_CLOSE, x)); 
} 

//+------------------------------------------------------------------+
//| Moving Average of Oscillator                                     |
//+------------------------------------------------------------------+
int start()
  {
   int limit;
   int counted_bars=IndicatorCounted();
   
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
   
//---- preparing the HMA
   for(int i=0; i<limit; i++) {
   	PreHMA1[i] = 2*WMA(i, FastHMA/2) - WMA(i, FastHMA); 
   	PreHMA2[i] = 2*WMA(i, SlowHMA/2) - WMA(i, SlowHMA); 
   }

//---- macd counted in the 1-st additional buffer
   for(i=0; i<limit; i++)
   	OsmaBuffer[i]= iMAOnArray(PreHMA1, 0, pF, 0, MODE_LWMA, i) - iMAOnArray(PreHMA2, 0, pS, 0, MODE_LWMA, i);
 
  for(i=0; i<limit; i++){
      Uptrend[i] = EMPTY_VALUE; if (OsmaBuffer[i]> OsmaBuffer[i+1]) {Uptrend[i+1] = OsmaBuffer[i+1]; Uptrend[i] = OsmaBuffer[i]; }
      Dntrend[i] = EMPTY_VALUE; if (OsmaBuffer[i]< OsmaBuffer[i+1]) {Dntrend[i+1] = OsmaBuffer[i+1]; Dntrend[i] = OsmaBuffer[i]; }

     }
    
//---- done
   return(0);
  }
//+------------------------------------------------------------------+

